/* --------------------------------------------------------------------------------
  Mobile User Interface functions, Jun 2011 Gerard Payne
  Cut down version of IOP.MOBILE.js for devices viewing mobile site
v.1
	Namespaces:
		IOP.MOBILE.debug	| enumerate(any object)
						| whatis(JQuery element) (TODO: incomplete)
		_____________________________________________________________
		IOP.MOBILE.plugins	| load external JS/CSS
		_____________________________________________________________
		IOP.MOBILE. 		| accordion.init()		|accordion object
						| citations.init()		|popup citations
						| closeall()			|close tabs/overlay/citations on clicking document
		_____________________________________________________________
		[foo] - indicates platform not supported
		[foo*]- partial support
-------------------------------------------------------------------------------- */
if(typeof(IOP) == "undefined"){var IOP = {};}//as the main IOP scripts are (probably) not used we need to make a namespace but allow for the possibility it might be there in future.

IOP.MOBILE = {
	debug: {
		enumerate: function(varObj, output){
			var arrObj = new Array();
			var i = 0;
			for(var key in varObj){
				arrObj[i]=key + " : " + varObj[key] + "\n";
				i++;
			}
			alert(arrObj);
		},
		whatis: function(varObj){
			objectIs = new Array();
			objectIs.type 		= typeof(varObj);
			objectIs.id 		= varObj.attr('id');
			objectIs.classname  = varObj.attr('class');
			objectIs.parentname = varObj.parent().attr('id');
			objectIs.siblingname= varObj.siblings().attr('id');
			objectIs.childname  = varObj.children().attr('id');
			objectIs.hasCSS		= varObj.style;
			objectIs.hasMethod	= varObj.data();
			arrObj = new Array();
			var i = 0;
			for(var key in objectIs){
				arrObj[i]=key + " : " + objectIs[key] + "\n";
				i++;
			}
			alert(arrObj);
		},
		firebug: function(){
			IOP.MOBILE.plugins.firebug();
			var link = document.createElement('a');
				link.setAttribute('href',"javascript:(function(F,i,r,e,b,u,g,L,I,T,E){if(F.getElementById(b))return;E=F[i+'NS']&&F.documentElement.namespaceURI;E=E?F[i+'NS'](E,'script'):F[i]('script');E[r]('id',b);E[r]('src',I+g+T);E[r](b,u);(F[e]('head')[0]||F[e]('body')[0]).appendChild(E);E=new%20Image;E[r]('src',I+L);})(document,'createElement','setAttribute','getElementsByTagName','FirebugLite','4','firebug-lite.js','releases/lite/latest/skin/xp/sprite.png','https://getfirebug.com/','#startOpened');");
			var icon = document.createElement('img');
				icon.setAttribute('src',"http://t1.gstatic.com/images?q=tbn:ANd9GcTBQwmdIp5dh6bCgN0u8kHbD1Y-C8nxzrznLXpqhNKnQDg8Rnzq");
				icon.setAttribute('title',"launch Firebug");
				icon.setAttribute('alt',"launch Firebug");
				icon.style.position = "absolute";
				icon.style.position = "fixed";
				icon.style.right = "50px";
				icon.style.top   = "50px";
				icon.style.border= "1px solid #aaaaaa";
				link.appendChild(icon);
				jQuery('body').append(link);
		}
	},
/* ----------------------------------------------------------------------------- */
	plugins:{//load plugins when needed (ideally call this from relevant functions instead of loading every plugin on every page)
		jQtools: function(){
			var jsfile = document.createElement('script');
			jsfile.setAttribute('type',"text/javascript");
			jsfile.setAttribute('src', "js/plugins/jquery.tools.min.js");
			jQuery('head').append(jsfile);
			
			var cssfile= document.createElement("link");
			cssfile.setAttribute('rel', "stylesheet");
			cssfile.setAttribute('type',"text/css");
			cssfile.setAttribute('href',"js/plugins/jquery.tools.css");
			jQuery('head').append(cssfile);
		},
		
		firebug: function(){
			var jsfile = document.createElement('script');
			jsfile.setAttribute('type',"text/javascript");
			jsfile.setAttribute('src', "js/lib/firebug.js");
			jQuery('head').append(jsfile);
		},
		
		loadall: function(){//don't do this, it's here to demonstrate the method only
			alert("A script on this page has requested the browser load ALL plugins.\nThis isn't a great idea.");
			this.jQtools();
			this.firebug();
		}
	},
/* ----------------------------------------------------------------------------- */
// Generic functions (should work on all platforms)
/* ----------------------------------------------------------------------------- */
	authors: {
		init: function(){
			jQuery("a.switchAuthorLists").click(function(e) {
				jQuery("div#articleEvoContainer .authors").toggleClass("openable").toggleClass("opened");
				e.preventDefault();
			});
			jQuery("a.openAffiliations").click(function(e) {
				var me = jQuery(this);
				me.toggleClass("openable").toggleClass("opened");
				if (me.hasClass("opened")) {
					me.next(".affiliationDetail").show();
					me.text("Hide affiliations");
				} else {
					me.next(".affiliationDetail").hide();
					me.text("Show affiliations");
				}
				e.preventDefault();
			});
		}
	},
	/* ----------------------------------------------------------------------------- */
	articleaccordion: {
		init: function(){
			jQuery("div#articleEvoContainer a.sectionHeadingAnchor").each(function() {
				var me = jQuery(this);
				me.toggleClass("off");
				me.parent().next("div.chapter").hide();
			});

			jQuery("div#articleEvoContainer a.sectionHeadingAnchor").not('#artAbst').click(function(e) {
				var me = jQuery(this);
				me.toggleClass("on");
				me.toggleClass("off");
				me.parent().next("div.chapter").toggleClass("open").animate({ "height": "toggle" }, { duration: 590 });
				e.preventDefault();
			});

			jQuery("div#articleEvoContainer div.chapter a.closeChap").click(function() {
				var me = jQuery(this);
				me.parent().prev().children("a.sectionHeadingAnchor").toggleClass("on");
				me.parent().prev().children("a.sectionHeadingAnchor").toggleClass("off");
				me.parent().toggleClass("open").animate({ "height": "toggle" }, { duration: 590 });
			});
		}
	},
	/* ----------------------------------------------------------------------------- */
	citations: {
		createtooltip:function(src){
			//holder for the target citation id/name
			var sourceobj= jQuery(src);
			var citation = jQuery(sourceobj.attr('href')).parent();
			//make the tooltip
			var tooltip = jQuery('<div/>');
			tooltip.addClass('tooltip').css({
				top : (sourceobj.offset().top + 16) + 'px',
				left : (sourceobj.offset().left + 10) + 'px'
			});
			IOP.MOBILE.citations.updatetooltip(citation,tooltip);
			jQuery('body').append(tooltip);
		},

		updatetooltip:function(citation,tooltip){
			// clean up the existing tooltip
			tooltip.empty();
			// make a close button
			var closebutton = jQuery('<div>');
			closebutton.addClass('closebutton').click(function(){
				IOP.MOBILE.citations.destroytooltip();
				return(false);
			});
			tooltip.append(closebutton);
			// create anchor to reference in list
			var referenceAnchor = jQuery('<a>');
			referenceAnchor.attr('href', '#' + citation.children('a:first').attr('id'));
			var labelText = citation.children('a:first').text();
			// Replace upward arrows with downward arrows where applicable
			if (labelText == '\u2191') {
				referenceAnchor.text('\u2193');
			} else {
				referenceAnchor.text(labelText);
			}
			tooltip.append(referenceAnchor);
			tooltip.append(' ');
			tooltip.append(citation.next().html());
			// if this is a reference group, we need to append the copy for other
			// references in the group.
			var nextRef = citation.next().next();
			while (nextRef.size() != 0 && nextRef.children('a:first').text() == '') {
				tooltip.append(jQuery('<br>'));
				tooltip.append(nextRef.next().html());
				nextRef = nextRef.next().next();
			}
			// get the previous reference that isn't in the middle of a reference group
			var prevRef = citation.prev().prev();
			while (prevRef.size() != 0 && prevRef.children('a:first').text() == '') {
				prevRef = prevRef.prev().prev();
			}
			// If either a previous or next reference exists, add a line break
			if (prevRef.size() != 0 || nextRef.size() != 0) {
				tooltip.append(jQuery('<br>'));
			}
			// previous reference link
			if (prevRef.size() != 0) {
				var prevRefId = prevRef.children('a:first').attr('id');
				var prevAnchor = jQuery('<a>');
				prevAnchor.addClass('tooltipPrev').attr('href', '#' + prevRefId)
						  .html('<img src="/img/v-sm-arrow-l.gif" alt="&ldquo;"/> Previous');
				prevAnchor.click(function(){
					var citation = jQuery(jQuery(this).attr('href')).parent();
					var tooltip = jQuery('.tooltip');
					IOP.MOBILE.citations.updatetooltip(citation,tooltip);
					return(false);
				});
				tooltip.append(prevAnchor);
				// If there's also a next reference link, add a space
				if (nextRef.size() != 0) {
					tooltip.append(' ');
				}
			}
			// next reference link
			if (nextRef.size() != 0) {
				var nextRefId = nextRef.children('a:first').attr('id');
				var nextAnchor = jQuery('<a>');
				nextAnchor.addClass('tooltipNext').attr('href', '#' + nextRefId)
						  nextAnchor.html('Next <img src="/img/v-sm-arrow-r.gif" alt="&rdquo;"/>')
						  .click(function(){
							var citation = jQuery(jQuery(this).attr('href')).parent();
							var tooltip = jQuery('.tooltip');
							IOP.MOBILE.citations.updatetooltip(citation,tooltip);
							return(false);
						  });
				tooltip.append(nextAnchor);
			}
		},
		
		destroytooltip:function(){
			jQuery('body').find('.tooltip').remove();
		},
		
		init:function(){
			//click event for links with class "cite"
			jQuery('a.cite').click(function(){
				IOP.MOBILE.citations.destroytooltip();
				IOP.MOBILE.citations.createtooltip(this);
				return(false);
			});
		}
	}
};
/* ----------------------------------------------------------------------------- */
//End of object literal
/* ----------------------------------------------------------------------------- */

jQuery(document).click(function(){
	IOP.MOBILE.citations.destroytooltip();//close tooltips
});

jQuery(document).ready(function(){
	/* ------------------------------------------------------------------------- */
	//Debugging
	var userAgent = navigator.userAgent.toLowerCase();
	switch(true){
		case(
			userAgent.indexOf('iphone')!= -1||
			userAgent.indexOf('ipad')  != -1||
			userAgent.indexOf('ipod')  != -1||
			userAgent.indexOf('android') != -1||
			userAgent.indexOf('series60')!= -1||
			userAgent.indexOf('symbian') != -1||
			userAgent.indexOf('blackberry') != -1||
			jQuery.browser.msie):
				if(window.location.href.indexOf("iopsci9")!= -1||
				   window.location.href.indexOf("kmj.iopscience")!= -1)
					{IOP.MOBILE.debug.firebug();}
				break;
	}
	/* ------------------------------------------------------------------------- */
	IOP.MOBILE.articleaccordion.init();
	IOP.MOBILE.authors.init();
	IOP.MOBILE.citations.init();
});